/******************************************/
/*        2 Kanal RFM12B RS485 Dimmerpack */
/*            Kay Bohn                    */
/******************************************/




#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdlib.h>
#include <avr/eeprom.h>

#include <math.h>
#include <util/delay.h>
#include "param.h"

#include "eeprom.h"
#include "one_wire.h"
#include "temp_mess.h"



//#include "uart.h"
//#include "rs485.h"
#include "rfm12b.h"




//#define UART_BAUD_RATE		  76800// 250000


 char     msg[50];					  // globale Variable zur Zeichenkonvertierung
 uint8_t  id[9];					  // fr den ROM-Adressen und Scratchboard
 uint8_t  sensor_cnt;				  // Anzahl der erfolgreich angelernten Sensoren

//RFM12
// define USE_868 in der rf12.c zum Umschalten zwischen 433 (auskommentiert) und 868MHz (aktiv) verwenden! Bei der 868MHz Version ist die Einhaltung der maximalen Sendedauer bei den einzelnen Kanlen zu beachten!

#define CHANNEL			2			// Sende/Empfangskanal (0-3) (nur gltig wenn kein DIP Schalter verwendet wird)
#define RF_BAUDRATE		4800		// Baudrate des RFM12 (nur gltig wenn kein DIP Schalter verwendet wird)

 char rxbuf[32+1];		// Puffer fr empfangene Daten
 char txbuf[32+1];		// Puffer fr zu sendende Daten

 // uint8_t  id[9];					    // fr den ROM-Adressen und Scratchboard
 //uint8_t  ow_buffer[9];					// fr den ROM-Adressen und Scratchboard
	
volatile unsigned int a = 0;
volatile unsigned int b = 0;
volatile unsigned int light1 = 0;
volatile unsigned int light2 = 0;

volatile unsigned int time1 = 50;
volatile unsigned int time2 = 50;

//volatile unsigned int sollTime1 = 0;
//volatile unsigned int sollTime2 = 0;
volatile unsigned char sollTime1 = 0;
volatile unsigned char sollTime2 = 0;

volatile unsigned char kanal = 0;
volatile unsigned char step  = 10;          //Schrittweite fr nderung pro Tastendruck

volatile unsigned int hunderstelsekunde;
volatile unsigned int dimmzeit = 1000;

volatile unsigned int kanalblinktime;
volatile unsigned int kanalblinkzeit = 9000;


volatile unsigned int prelltime;
volatile unsigned int prellzeit = 1000;


volatile unsigned char K1LEDfl = 0;
volatile unsigned char K2LEDfl = 0;
volatile unsigned char syncfl = 0;





 uint16_t device_Adr = 0x02;           // Gerteadresse 
 uint8_t device_ID;  




void port_init(void);
uint8_t EEPReadByte(uint16_t addr);

void rx_packet(void);

/*
//void EEPWriteByte(uint16_t addr, uint8_t val);
//void rx_packet(void);
//void read_T(void);
// Byte aus dem EEPROM lesen
uint8_t EEPReadByte(uint16_t addr)
{
  return eeprom_read_byte((uint8_t *)addr);
}
 
// Byte in das EEPROM schreiben
void EEPWriteByte(uint16_t addr, uint8_t val)
{
  eeprom_write_byte((uint8_t *)addr, val);
}

*/


void port_init( void )
{

//AUSGNGE PORTD
 DDRD =  (1<<K1LED_BIT  ) | (1<<K2LED_BIT  )| (1<<SCK)|(1<<CS)  ;//als ausgang
 
 //DDRD |=  (1<<K1LED_BIT  ) | (1<<K2LED_BIT  ) | (1<<SCK)|(1<<CS) ;//als ausgang
 PORTD = (1<<CS) ;

//AUSGNGE PORTC
 DDRC = (1 << TRIAC2_BIT) | (1<<TRIAC1_BIT  ) | (1<<SYnc_LED_BIT  ) | (1<<ERROR_LED_BIT  )| (1<<SDI)   ;//als ausgang
 //DDRC |= (1 << TRIAC2_BIT) | (1<<TRIAC1_BIT  ) | (1<<SYnc_LED_BIT  ) | (1<<ERROR_LED_BIT  )| (1<<SDI)  ;//als ausgang
 DDRC&=~((1<<SDO));

//RF_DDR|=(1<<SDI)|(1<<SCK)|(1<<CS);

  // Configure debouncing routines

}



//Taster-Entprellung und Auswertung
//und Kanal-LED Ein-Aus-Schalten
ISR(TIMER2_OVF_vect)
{



  

  prelltime++;
  if(prelltime == prellzeit)
  {
    prelltime = 0;
	syncfl = 0;


	       
  



 
}

 
}



//Zero-Cross-Detectin
ISR(INT1_vect)
{
  a = TCNT1;
  b = a/100;
  TCNT1 = 0;
  
  TRIAC1_OFF();
  TRIAC2_OFF();

  syncfl = 1;
  //syncfl= !syncfl;

}


//Lampen-Dimmung und
//Kanal-LED Blink Zeit
ISR(TIMER0_OVF_vect)
{    
  hunderstelsekunde++;
  if(hunderstelsekunde == dimmzeit)
  {
     hunderstelsekunde = 0;
    
   if( time1 < sollTime1 )
     time1++;
    
   else if( time1 > sollTime1 )
     time1--;
    
   if( time2 < sollTime2 )
     time2++;
	
   else if( time2 > sollTime2 )
     time2--;
 
   if (kanal == 1) 
    {
	 light1 = b*time1;
    }
	
   if (kanal == 2) 
    {
	 light2 = b*time2;
    }	
  }

   if ((TCNT1 >= (a - light1)) && (TCNT1 <= (a - light1)+3))
    {
     TRIAC1_ON();
    }
   else
    {
     TRIAC1_OFF();
    }
    
   if ((TCNT1 >= (a - light2)) && (TCNT1 <= (a - light2)+2))
    {
     TRIAC2_ON();
    }
   else
    {
     TRIAC2_OFF();
    }
	



  kanalblinktime++;
  if(kanalblinktime == kanalblinkzeit)
   {
	 kanalblinktime = 0;
     syncfl = 0;

   if (kanal == 1)
    {
     K2LEDfl= 0;        //auf 0  setzen
     K1LEDfl= !K1LEDfl; //Variable mit einem ! ist ein logisches NICHT Toggeln beliebige Zahl ungleich 0    ->  0
    }
  
   if (kanal == 2) 
    {
     K1LEDfl= 0;        //auf 0  setzen
     K2LEDfl= !K2LEDfl; //Variable mit einem ! ist ein logisches NICHT Toggeln beliebige Zahl ungleich 0    ->  0
    }

   if(K1LEDfl == 1)
    {
     K1LED_ON();
    }
   else
    {
     K1LED_OFF();
    }

   if(K2LEDfl == 1)
    {
     K2LED_ON();
    }
   else
    {
     K2LED_OFF();
    } 

  }
  

  
  



    if(syncfl == 1)
    {
     SYnc_LED_OFF();
    }
    else
    {
     SYnc_LED_ON ();
    }
     
   
   
}
 
 
 

 
 
 
 
 
 
 
 

int main(void) __attribute__((OS_main));
int main(void)
{	
	
 cli();
   port_init();
// uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) ); 


	
//*******************
  TCCR2 = (1<<CS00);    // No prescaling
  TCNT2 = 0;//TIMER2 Startwert 

  TCCR0 = (1<<CS00);    // No prescaling 
  TIMSK = (1<<TOIE0)|(1<<TOIE2);
    
  MCUCR = 0b00001100;
  GICR =  0b10000000;
  TCCR1B = 0b00000100;    //Timer1 starten

 sei();
  
  ERROR_LED_ON();
  
//Triacs erstmal Ausschalten  
  TRIAC1_OFF();
  TRIAC2_OFF();
 
//Werksseitige voreingestellte EEpromspeicheradresse und Gerteadresse
 // EEPWriteByte(device_Adr, 55);          // Byte=55 an die Adresse 0x02 schreiben

  device_ID=ee_read_byte(device_Adr);     // Gerteadresse von Adresse 0x02 lesen  



 // PORT_UART_OUT &= ~( 1 << PIN_UART_OUT );

 
	rf12_init();									// ein paar Register setzen (z.B. CLK auf 10MHz)
	rf12_config(RF_BAUDRATE, CHANNEL, 0, QUIET);	// Baudrate, Kanal (0-3), Leistung (0=max, 7=min), Umgebungsbedingungen (QUIET, NORMAL, NOISY)
    rf12_rxmode();




  
  
           device_ID=50 ;//EEPReadByte(device_Adr);   // Gerteadresse von Adresse 0x02 lesen 		   
			
            //setTransmitMode();												 
		    //uart_putc(device_ID);				  // device_ID ausgeben 						
            //setReceiveMode();		 


kanal=1;

//mainloop:
 for (;;)
 {
/*
   if ( (UCSRA & (1<<RXC)) )                   // Zeichen wurde empfangen, 
    {
                                               
        c =   uart_getc();                       // Hole Daten vom UART ab 
         
   
    if (c==0xC0)				                     // Dimmzeit einstellen 
	{
	     c1=uart_getc();
         if (c1==device_ID)	                      // Stimt die Gerte adresse
	       {
	 
	         c2=uart_getc();
	  
	           if (c2==0xF0)
				{
			  	 dimmzeit=1000;
				}
		 
			   if (c2==0xF1)
				{
				 dimmzeit=2000;
				}			  
		       
			   if (c2==0xF2)
		        {
				 dimmzeit=3000;
				}			  			  
		       
	           if (c2==0xF3)
				{
	             dimmzeit=4000;
				}			  			  			  
		       
			   if (c2==0xF4)
				{
				 dimmzeit=5000;
				}			  			  
		       
	           if (c2==0xF5)
				{
				 dimmzeit=6000;
				}			  			  
	    
			   if (c2==0xF6)
				{
				 dimmzeit=7000;
				}			  			  
	      
	           if (c2==0xF7)
	            {
			  	 dimmzeit=8000;
				}			  			  
		       
			   if (c2==0xF8)
				{
				 dimmzeit=9000;
				}			  			
		   
			   if (c2==0xF9)
				{
				 dimmzeit=10000;
				}			  			
	        }	  
	}

    else if (c==0xC1)				           // Schrittweite fr nderung pro Tastendruck 
	{
	 c1=uart_getc();
       if (c1==device_ID)	                   // Stimt die Gerte adresse
	    {
		 c2=uart_getc();
	     step=c2;
	    }
    }
 	
    else if (c==0xC2)				            // Dimmwert fr Kanal 1
	{
	 c1=uart_getc();
       if (c1==device_ID)	                    // Stimt die Gerte adresse
	    {
	     kanal=1;
	     c2=uart_getc();
	      if (c2>100)
	          c2=100;
	          sollTime1=c2;   
	    }
    }

	
   else if (c==0xC3)				            // Dimmwert fr Kanal 1 
	{
	 c1=uart_getc();
       if (c1==device_ID)	                    // Stimt die Gerte adresse
	    {
		 kanal=2;
	     c2=uart_getc();
	      if (c2>100)
	          c2=100;
	          sollTime2=c2;   	   
	    }
    }
	
   else if (c==0xC4)				            // Dimmwert fr Kanal 1 und Kanal 2
	{
	 c1=uart_getc();
       if (c1==device_ID)	                    // Stimt die Gerte adresse
	    {
		 kanal=1;   
		 kanal=2;
	     c2=uart_getc();
	      if (c2>100)
	          c2=100;
	          sollTime1=c2;  
	          sollTime2=c2;  
	   
	    }
    }
	
   
   else if (c==0xC5)				            // Gerte-Adresse Neu schreiben
	{
	 c1=uart_getc();
       if (c1==device_ID)	                    // Stimt die Gerte adresse
	    {
		 c2=uart_getc();
	     device_ID=c2;
         EEPWriteByte(device_Adr, device_ID);   // Byte an die Adresse  schreiben
	     device_ID=EEPReadByte(device_Adr);     // Neue Gerteadresse  lesen 
        }
	}

   else if (c==0xC6)			                      // Gerteadresse von Adresse  lesen und senden  
	    {
	     c1=uart_getc();
         if (c1==device_ID)	                      // Stimt die Gerte adresse
	       {
            device_ID=EEPReadByte(device_Adr);   // Gerteadresse von Adresse 0x02 lesen 		   
			
            setTransmitMode();												 
		    uart_putc(device_ID);				  // device_ID ausgeben 						
            setReceiveMode();		   
		   }
	    }     
	}
  
    else
        {
         // Kein Zeichen empfangen, Restprogramm ausfhren...
           if( get_key_short( 1<<KEY1 )){
             kanal=1;
	         sollTime1+=step;
	          if (sollTime1>=100)
	              sollTime1=100;
	        } 

		   if( get_key_long( 1<<KEY1 )){
			 kanal=1;			 
			 sollTime1=100;
			} 
         
		   if( get_key_short( 1<<KEY2 )){ 
			 kanal=1;
			 sollTime1-=step;
				if (sollTime1<=0)
					sollTime1=0;
			} 
         
		   if( get_key_long( 1<<KEY2 )){
			 kanal=1;
			 sollTime1=0;
			}

		   if( get_key_short( 1<<KEY3 )){
             kanal=2;
			 sollTime2+=step;
			    if (sollTime2>=100)
					sollTime1=100;
			} 

		   if( get_key_long( 1<<KEY3 )){
			 kanal=2;			 
			 sollTime2=100;
			} 
         
		   if( get_key_short( 1<<KEY4 )){
			 kanal=2;
			 sollTime2-=step;
	            if (sollTime2<=0)
					sollTime2=0;
			} 
         
		   if( get_key_long( 1<<KEY4 )){
			 kanal=2;
			 sollTime2=0;
			}

		rx_packet();
		  
	   }
*/

rx_packet();
  }
}




void rx_packet(void)
{  uint8_t  Len;	  
 
  rf12_rxdata_test(rxbuf,3);	

   
   
   if (rxbuf[0] == device_ID)//if (device_ID == rxbuf[0])	
	{
	   K1LED_ON();
       
	   //Dimmen Kanal 1
	   if (rxbuf[1] == Komand_channel_1)				                     //  
	    {
         kanal=1;
	      
		  if (rxbuf[2]==100)
	        {
             sollTime1 = 85;
            } 
		  
		  else
	        {
             sollTime1=rxbuf[2];
            }
 		}
		
	   //Dimmen Kanal 2
	   if (rxbuf[1] == Komand_channel_2)				                     //  
	    {
		 kanal=2;
		  if (rxbuf[2]==100)
	        {
             sollTime2 = 85;
            } 
		  
		  else
	        {
             sollTime2=rxbuf[2];
            }
        }
	   
	   
	   
	   //Dimm-Daten Abfragen Kanal 1 und 2	
       if (rxbuf[1] == Komand_channel_3)				                     //  
	    {
		//kanal=2;
		// txbuf[0]= 50;
        // txbuf[1]= sollTime1;
		// txbuf[2]= sollTime2;
		// rf12_txdata_TEST(txbuf, 3);
		sprintf(txbuf,"%d,%d,%d",device_ID ,sollTime1, sollTime2);	
		
		Len = strlen (txbuf);
		
		rf12_txdata_TEST(txbuf,Len);		
		
		} 
        	    
				

		
	    if (rxbuf[1] == DATA_READ)				                     //  
	    {
            kanal=1;
			
		    //ds1820_read_temp(DS1820_pin_po);

			kanal=2;	
        }

	    if (rxbuf[1] == DATA_READ_Rom)				                     //  
	    {
            kanal=1;
			
		    //read_rom(DS1820_pin_po);
OW_read_rom_code(); 
			kanal=2;	
        }

	    if (rxbuf[1] == DATA_READ_k)				                     //  
	    {
            kanal=1;

			DS18S20_convert_temperatur();   // von dort holt sich die Funktion die Messwerte und wandelt sie um,
			
			kanal=2;	
        }

	    if (rxbuf[1] == 7)				                     //  
	    {
            kanal=1;

		    DS18S20_convert_temperatur_2();   // von dort holt sich die Funktion die Messwerte und wandelt sie um,
			
			kanal=2;	
        }

	    if (rxbuf[1] == 8)				                     //  
	    {
            kanal=1;

			rom(); 
			
			kanal=2;	
        }
		
	}	
		

    else  //Keine daten ber RFM12B
    {
     
    }
	/**/	
rxbuf[0]= 255;	
rxbuf[1]= 255;			
rxbuf[2]= 255;			

}

/*
void read_T(void)
{
 int16_t x;
    uint8_t i, j, crc,Len;
    volatile uint8_t rc;  // volatile is used for timing measurement in simulation, not required for normal application
    uint8_t i_ds18B20, i_ds18S20;
    int16_t temp, vorkomma, nachkomma;

   //Serial.begin(9600);
    //Serial.println(F("\r\nOneWire (tm) demo"));
    // speed test in simulator, set breakpoints on next two lines
   rf12_txdata_TEST("DEMO",4);
    rc=onewire_crc(buffer, 8);
    rc;
    // single device on bus, simple access without ROM code
    //Serial.println(F("\r\nReading ROM code of single device on bus."));
    rc=onewire_read_rom(buffer);    
    for (i=0, j=0; i<8; i++) j |= buffer[i];    // or all data
    crc=buffer[7];
    buffer[7]=0;
    
	if (rc==1)
    {
        //Serial.println(F("No response on bus!"));
        rf12_txdata_TEST("No response on bus!",21);
		while(1);    // stop here
    } 
	
	else if (rc==2) 
	{
       rf12_txdata_TEST("crc error",11);
       // Serial.println(F("CRC error! "));
        //Serial.print(F("Received CRC  : 0x"));
        //Serial.println(crc, HEX);
        //Serial.print(F("Calculated CRC: 0x"));
        //Serial.println(onewire_crc(buffer, 8), HEX);
        //Serial.println(F("There is probably more than one device on the //bus.\r\n"));
    } 
	
	else if (j==0) 
	{
        //Serial.println(F("All rom data zero."));
        //Serial.println(F("There is probably more than one device on the //bus.\r\n"));    
     rf12_txdata_TEST("All rom data zero",21);
	}
    
	buffer[7]=crc;
    //print_header();
    //print_rom(buffer, 0);
    // check if DS18S20 or DS18B20 are found on bus
    if (buffer[0]==DS18S20_ID) i_ds18S20 = 1; else i_ds18S20 = 0;       // family code for DS18S20
    if (buffer[0]==DS18B20_ID) i_ds18B20 = 1; else i_ds18B20 = 0;       // family code for DS18B20
    // read complete scratchpad (9 bytes)
    
	if (i_ds18S20 || i_ds18B20) 
	{
        onewire_skip_rom();
        ds18x20_read_scratchpad(buffer);
        if (onewire_crc(buffer, 9)) 
		{
            //Serial.println(F("CRC error in scratchpad data!"));
        rf12_txdata_TEST("CRC error in scratchpad data",21);
		}
        //print_scratchpad(buffer);
		 rf12_txdata_TEST((char*)buffer,10);
    }
    
	// temperature reading using normal power
    if (!i_ds18S20) 
	{ 
        //Serial.println(F("\r\nNo DS18S20 found on bus."));
		 rf12_txdata_TEST("No DS18S20 found on bus.",21);
    } 
	
	else 
	{
       // Serial.println(F("\r\nReading temperature of DS18S20 (9 Bit, 0.5 C resolution)"));
        //Serial.println(F("DS18S20 must be normal powered!"));
        //Serial.println(F("Press any key to stop"));
        rf12_txdata_TEST("Reading temperature.",21);
		//while(22)
        //{
            onewire_skip_rom();
            ds18S20_convert_t(0);        // normal power
            _delay_ms(750);
            onewire_skip_rom();
            x = ds18S20_read_temp();
            //Serial.print(F("T: "));
            //Serial.print(x/10);
            //Serial.print('.');
            //Serial.print(abs(x)%10);
            //Serial.println(F(" C"));
        vorkomma = x/10;
		nachkomma = abs(x)%10;   
//sprintf(txbuf,"%d.%d ",vorkomma , nachkomma); 
  //Len = strlen (txbuf);
  //rf12_txdata_TEST(txbuf,Len);
  itoa( vorkomma, txbuf, 10 );
  Len = strlen (txbuf);
 rf12_txdata_TEST(txbuf,Len);
 
  itoa( nachkomma, txbuf, 10 );
  Len = strlen (txbuf);
 rf12_txdata_TEST(txbuf,Len); 
 


       //}
    } 
}


*/








