#include <stdio.h>
#include <stdlib.h>
#include <string.h>	
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>



#include <util/delay.h>

#include "param.h"

#include "one_wire.h"

#include "temp_mess.h"
#include "eeprom.h"


//#include "uart.h"
//#include "rs485.h"
#include "rfm12b.h"



uint8_t OW1_read_scratchpad(uint8_t idx)
{uint8_t  Len;	 

    uint8_t i;		
cli(); 
    EEPROM_read_rom_code(idx);						// den zugehrigen ROM-Code aus dem
	

	d1w_init();
	d1w_write(D1W_SKIP_ROM);                       // skip rom
	d1w_write(D1W_CONVERT_T);

	_delay_ms(750);
	
	d1w_init();
	d1w_write(D1W_MATCH_ROM);                      // einen sensor mit seiner id direkt ansprechen

    for (i = 0; i < 8; i++) d1w_write(id[i]);


	d1w_write(D1W_READ_SCRATCHPAD);

    for (i = 0; i < 9; i++) id[i] = d1w_read();
    d1w_init();
	
 sei();
   
Len = strlen (txbuf);
rf12_txdata_TEST(msg,Len);	
	return (id[8] == docrc8(8));        
}
  
  
// ----------------------------------------------------------------------------
// wandelt den Messwert, um.
void DS18S20_convert_temperatur(void)
{  uint8_t  Len;	 

     uint8_t i;

    int temp;
    int16_t Vorkommastelle;
    uint8_t Nachkommastelle;
   
cli();
	d1w_init();
	d1w_write(D1W_SKIP_ROM);                       // skip rom
	d1w_write(D1W_CONVERT_T);

	_delay_ms(1000);
	
	d1w_init();
    d1w_write(D1W_SKIP_ROM); 
    d1w_write(D1W_READ_SCRATCHPAD);   // Auslesen des Scratch Pads vom DS1820
    
	for (i = 0; i < 9; i++) id[i] = d1w_read();

    d1w_init();

sei();

    if( id[1] ) {                // Negativer Temperaturwert
    id[0] ^= 0xFF;               // Einer-Komplement
    id[0]++;                     // inkrementieren
    }
    id[0] >>= 1;                 // rechtes Bit fr 0,5 C rausschieben (durch 2 teilen)
    
  // Temperatur mit 0,1 C Genauigkeit berechnen
    temp = (int)id[0]*100 - 25 + (int)(id[7] - id[6]) * 100 / id[7];
    
     if( id[1])                   // Negativer Temperaturwert
      {
       temp *= -1;
       //temp /= 10; // Zweite Nachkommastelle abtrennen
	  }

     else
      {
          
      }
 
     Vorkommastelle = temp / 100;
     Nachkommastelle = (temp % 100);      
     Nachkommastelle = Nachkommastelle % 10;// Zweite Nachkommastelle abtrennen
	
     sprintf(msg,"%+03d,%1d", Vorkommastelle, Nachkommastelle);    

    Len = strlen (txbuf);
	rf12_txdata_TEST(msg,12);
}


// wandelt den Messwert, um.
void DS18S20_convert_temperatur_2(void)
{  uint8_t  Len;	 

     uint8_t i;

    int temp;
    int16_t Vorkommastelle;
    uint8_t Nachkommastelle;
   
cli();
	d1w_init();
	d1w_write(D1W_SKIP_ROM);                       // skip rom
	d1w_write(D1W_CONVERT_T);

	_delay_ms(1000);
	
	d1w_init();
    d1w_write(D1W_SKIP_ROM); 
    d1w_write(D1W_READ_SCRATCHPAD);   // Auslesen des Scratch Pads vom DS1820
    
	for (i = 0; i < 9; i++) id[i] = d1w_read();

    d1w_init();

sei();

    if( id[1] ) {                // Negativer Temperaturwert
    id[0] ^= 0xFF;               // Einer-Komplement
    id[0]++;                     // inkrementieren
    }
    id[0] >>= 1;                 // rechtes Bit fr 0,5 C rausschieben (durch 2 teilen)
    
  // Temperatur mit 0,1 C Genauigkeit berechnen
    temp = (int)id[0]*100 - 25 + (int)(id[7] - id[6]) * 100 / id[7];
    
     if( id[1])                   // Negativer Temperaturwert
      {
       temp *= -1;
       //temp /= 10; // Zweite Nachkommastelle abtrennen
	  }

     else
      {
          
      }
 
     Vorkommastelle = temp / 100;
     Nachkommastelle = (temp % 100);      
     Nachkommastelle = Nachkommastelle % 10;// Zweite Nachkommastelle abtrennen
	
     sprintf(msg,"%+03d,%1d", Vorkommastelle, Nachkommastelle);    

    Len = strlen (txbuf);
	rf12_txdata_TEST(msg,12);
}


void rom(void)
{uint8_t i = 0;
uint8_t  Len;	 

cli();
		d1w_init();
		d1w_write(D1W_READ_ROM);  
 for ( i = 0; i < 8; i++) 
  {
    rxbuf[i] = d1w_read();
  }
sei();

sprintf(txbuf,"%d.%d.%d.%d.%d.%d.%d.%d.%d",rxbuf[0],rxbuf[1],rxbuf[2],rxbuf[3],rxbuf[4],rxbuf[5],rxbuf[6],rxbuf[7],rxbuf[8]); //Convert temp. puffer oben to string
Len = strlen (txbuf);
rf12_txdata_TEST(msg,Len);

}


 





  
// ----------------------------------------------------------------------------
// liest den ROM-Code des in diesem Moment einzigen (!) angeschlossenen One-Wire-Devices,
// der ROM-Code steht anschlieend im globalen Array id[].
// Danach wird die CRC geprft
// Rckgabe: - TRUE wenn CRC und Family-Code stimmt 
uint8_t OW_read_rom_code(void)
{
 uint8_t i;
uint8_t  Len;
  //setTransmitMode();	

  d1w_init();
  d1w_write(D1W_READ_ROM);                          // READ_ROM 

   for (i = 0; i < 8; i++) id[i] = d1w_read();

   for (i = 0; i < 8; i++) 						// ROM-Code ausgeben
	{
	 sprintf(msg,"%03d", id[i]);
	 //uart_puts(msg);
	 Len = strlen (msg);
	 rf12_txdata_TEST(msg,Len);
	}

   if ((id[7] == docrc8(7)) && (id[0] == DS18S20))
	{         
	 //uart_puts(" crc ok   ");
     //uart_putc(device_ID);			 	            // device_ID ausgeben 
	 //setReceiveMode();
	 Len = strlen (msg);
	 rf12_txdata_TEST(" crc ok   ",Len);
	 return (TRUE);									// TRUE zurckgeben, wenn CRC identisch
	}
  
   else 
	{
	//uart_puts(" crc error");						   // Fehlermeldung geben, wenn CRC nicht stimmt
	//uart_putc(device_ID);				           // device_ID ausgeben 
	//setReceiveMode();
	Len = strlen (msg);
	rf12_txdata_TEST(" crc error   ",Len);
	return (FALSE);
	}
}
  
 
// ----------------------------------------------------------------------------
// liefert FALSE, wenn im EEPROM kein Platz mehr fr Sensordaten ist,
// sonst den Index fr den nchsten freien Speicherplatz 
// Die Eeprom-Adresse wird aus dem Index ermittelt durch Multiplikation mit 8 !
uint8_t OW_eeprom_free(void)
{
uint16_t i;
for (i = 1; i < (EEPROM_SIZE / 8); i++)	         // die Adressen 0 - 7 sind reserviert
	{
	if (ee_read_byte(i * 8) == 0xFF)
		{
		return(i);									 // die erste Stelle zurckgeben, an der
		}											 // Byte.0 == 0xFF
	}												 // denn bei einem Sensor muss hier der Family-Code stehen
return(0);											 // wenn kein freier Platz gefunden
}

// ----------------------------------------------------------------------------
// durchsucht das EEPROM, ob der neu angelernte ROM_CODE im Array ow_buffer[] 
// bereits im EEPROM gespeichert ist,
// liefert TRUE, wenn der Code bereits vorhanden ist !
uint8_t OW_rom_code_exists(void)
{
uint16_t i;
uint8_t j, z, result = FALSE;

for(i = 8; i < (EEPROM_SIZE - 8); i = i+8)
	{
	z = 0;
	for (j = 0; j < 8; j++)
		{
		if (ee_read_byte(i + j) == id[j]) z++;
		}
	if (z == 8) 
		{
		result = TRUE;								// wenn alle 8 Bytes identisch waren
		break;										// die Suche abbrechen
		}
	}

return (result);
}

// ----------------------------------------------------------------------------
// liest das EEPROM aus, ermittelt die Anzahl der Sensoren (sensor_cnt)
// liest das Messintervall (messintervall) ein.
//
void OW_read_eeprom(void)
{
uint16_t i;
sensor_cnt = 0;
for (i = 8; i < (EEPROM_SIZE - 8); i += 8)
	{
	if ((ee_read_byte(i) == DS18S20))		        // Family-Code muss 0x10 sein
		{
		sensor_cnt++;								// Anzahl der registrierten Sensoren
		}
	}
	
}


// ----------------------------------------------------------------------------
// liest den ROM_Code von Device idx (ROM-ADresse = idx * 8) aus dem EEProm
// und schreibt ihn in das globale Array id[]
// gibt TRUE zurck, wenn die CRC stimmt
uint8_t EEPROM_read_rom_code(uint8_t idx)
{
uint8_t i;
idx *= 8;											// jeweils 8 Byte bilden einen ROM_Code

for ( i = 0; i < 8; i++) id[i] = ee_read_byte(idx + i);

return (id[7] == docrc8(7));			            // wenn die CRC stimmt, TRUE zurckgeben
}

// ----------------------------------------------------------------------------
// schreibt den ROM_Code aus ow_buffer[] ins EEPROM an die Position idx
// die EEPROM-Adresse dazu ist mit vorher mit 8 zu multplizieren
void EEPROM_write_rom_code(uint8_t idx)
{
uint8_t i;
idx *= 8;											// jeweils 8 Byte bilden einen ROM_Code

for ( i = 0; i <  8; i++) ee_write_byte((idx + i), id[i]);
}


// ----------------------------------------------------------------------------
// vergleicht den ROM_Code aus ow_buffer[] mit dem im EEPROM an der Stelle idx
// liefert TRUE zurck, wenn ROM_CODE in ow_buffer[] == ROM_CODE im Eeprom
// Der ROM-Code steht an der EEPROM-Adresse idx * 8.
uint8_t EEPROM_compare_rom_code(uint8_t idx)
{
uint8_t i;
uint8_t cmp = TRUE;

idx *= 8;											// jeweils 8 Byte bilden einen ROM_Code

for ( i = 0; i < 8; i++) if(!(ee_read_byte(idx + i) == id[i])) cmp = FALSE;
return (cmp);
}